using System;

namespace TopCoder.Rules.DependencyMap.View.AccuracyTests.Enh1
{
	/// <summary>
	/// This class stores the width and height that where used to call the GetGraphics method.
	/// </summary>
	public class SpySVGRenderer : IDiagramRenderer
	{
		private int width = -1;
		private int height = -1;
		private SVGRenderer svg = null;

		public int GetWidth() 
		{
			return width;
		}
    
		public int GetHeight() 
		{
			return height;
		}

		public SpySVGRenderer (string filename)
		{
			svg = new SVGRenderer(filename);
		}
		
		public IGraphics GetGraphics(Dependency dependency, int width, int height) 
		{
			if ((width != 1) || (height != 1)) 
			{
				this.width = width;
				this.height = height;
			}
			return svg.GetGraphics(dependency, width, height);

		}
	}
}
