using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using NUnit.Framework;
using  TopCoder.Rules.DependencyMap.View;

namespace TopCoder.Rules.DependencyMap.View.AccuracyTests.Enh4
{
	/// <summary>
	/// Builds different maps and test the layout.
	/// 
    /// @author cucu
    /// Copyright (c)2005, TopCoder, Inc. All rights reserved
    /// </summary>
    [TestFixture]
	public class Enh4
	{
        protected DependencyRenderer renderer = null;
        protected Dependency a = null;
        protected Dependency b = null;
        protected Dependency c = null;
        protected Dependency d = null;
        protected Dependency e = null;
        protected Dependency f = null;
        protected Dependency g = null;
		protected Dependency h = null;
		protected Dependency i = null;
		protected SVGRenderer svgRenderer = null;

		protected  void Save(string test) 
		{
		}
		protected void Start(string test) 
		{
			svgRenderer = new SVGRenderer(@"../../test_files/enh4/" + test + "_result.svg");
			renderer.AddDiagramRenderer(svgRenderer);


		}
        [SetUp]
        protected void SetUp()
        {
            renderer = new DependencyRenderer();

            a = new Dependency("A");
            b = new Dependency("B");
            c = new Dependency("C");
            d = new Dependency("D");
            e = new Dependency("E");
            f = new Dependency("F");
            g = new Dependency("G");
			h = new Dependency("H");
			i = new Dependency("I");

        }
		/// <summary>
		/// Test the rule 1 of the specification
		/// </summary>
        [Test]
		public void Rule1()
		{
			Start("Rule1");
            
			a.AddDependant(b);
			a.AddDependant(e);            
			b.AddDependant(c);
			b.AddDependant(d);            
			e.AddDependant(c);

			renderer.Render(a);
           
		}

        /// <summary>
        /// Test the rule 2 of the specification
        /// </summary>
        [Test]
		public void Rule2()
		{
			Start("Rule2");
            
			a.AddDependant(b);
			a.AddDependant(e);            
			a.AddDependant(g);
			b.AddDependant(c);            
			b.AddDependant(d);
			e.AddDependant(f);
			g.AddDependant(h);
			g.AddDependant(d);

			renderer.Render(a);
           
		}

        /// <summary>
        /// Test the rule 3 a of the specification
        /// </summary>
		[Test]
		public void Rule3a()
		{
			Start("Rule3a");
            
			a.AddDependant(b);
			a.AddDependant(g);            
			b.AddDependant(c);            
			b.AddDependant(d);
			d.AddDependant(e);
			d.AddDependant(f);
			g.AddDependant(c);
			g.AddDependant(d);

			renderer.Render(a);
           
		}

        /// <summary>
        /// Test the rule 3 b of the specification
        /// </summary>
		[Test]
		public void Rule3b()
		{
			Start("Rule3b");
            
			a.AddDependant(b);
			a.AddDependant(e);
			a.AddDependant(g);            
			b.AddDependant(c);            
			b.AddDependant(d);
			e.AddDependant(c);            
			e.AddDependant(d);
			e.AddDependant(f);            

			g.AddDependant(d);
			g.AddDependant(h);
			g.AddDependant(c);

			renderer.Render(a);
           
		}


        /// <summary>
        /// Test the rule 3 c of the specification
        /// </summary>
		[Test]
		public void Rule3c()
		{
			Start("Rule3c");
            
			a.AddDependant(b);
			a.AddDependant(e);
			a.AddDependant(g);            
			b.AddDependant(c);            
			b.AddDependant(d);
			e.AddDependant(c);            
			e.AddDependant(d);
			e.AddDependant(f);            

			g.AddDependant(d);
			g.AddDependant(h);
			g.AddDependant(i);

			renderer.Render(a);
           
		}

	}
}
