/**
 * TCS Dependency Map Renderer
 *
 * Copyright (c) 2005 TopCoder, Inc. All rights Reserved.
 */
package com.topcoder.rules.dependencymap.view.AccuracyTests.Enh1;

import java.awt.image.BufferedImage;
import java.util.Set;

import com.topcoder.rules.dependencymap.view.Dependency;
import com.topcoder.rules.dependencymap.view.DiagramRenderer;
import com.topcoder.rules.dependencymap.view.RendererGraphics;
import com.topcoder.rules.dependencymap.view.AccuracyTests.MockGraphics;


/**
 *  Mock class that always return the same instance of MockGraphics
 *
 * @author cucu
 */
public class MockDiagramRendererWH implements DiagramRenderer {
    private int width = -1;
    private int height = -1;
    private MockGraphics graphics;

    public int getWidth() {
        return width;
    }

    public int getHeight() {
        return height;
    }

    /**
     * Build a MockDiagramRenderer that will contain a MockGraphics
     */
    public MockDiagramRendererWH() {
        graphics = new MockGraphics();
    }
    /**
     * Build a MockDiagramRenderer that will contain a MockGraphics
     */
    public MockDiagramRendererWH(BufferedImage buffImg) {
        graphics = new MockGraphics(buffImg);
    }

    public RendererGraphics getGraphics(Dependency dependency) {
        return graphics;
    }


    public RendererGraphics getGraphics(Dependency dependency, int width, int height) {
        if ((width != 1) || (height != 1)) {
            this.width = width;
            this.height = height;
        }
        return graphics;
    }

    public Set getLog() {
        return graphics.getLog();
    }
}
