/**
 * TCS Dependency Map Renderer
 *
 * Copyright (c) 2005 TopCoder, Inc. All rights Reserved.
 */
package com.topcoder.rules.dependencymap.view.AccuracyTests;

import java.awt.image.BufferedImage;
import java.io.File;
import java.util.Iterator;
import java.util.Set;

import javax.imageio.ImageIO;
import javax.imageio.ImageWriter;
import javax.imageio.stream.ImageOutputStream;

import com.topcoder.util.image.svg2dgraphics.SVGGraphics2D;

/**
 * This class provides various static methods to use while testing.
 *
 * @author cucu
 */
public class TestsHelper {

    /* Set to true to save the files and leave them in test_files to
     * see the results
     */
    private static boolean saveEnabled = true;

    /*
     * Mark here the enhancements the submitter has done
     */
    public static final boolean enh1 = false;
    public static final boolean enh2 = false;
    public static final boolean enh3 = false;
    public static final boolean enh4 = false;
    public static final boolean enh5 = false;
    public static final boolean enh6 = false;

    /**
     * Check it the logs sets are equal and display the differences if they are.
     *
     * @param test name of the test that is calling
     * @param expected expected set
     * @param result obtained set
     * @return true if they're equal
     */
    public static boolean compareResults(String test, Set expected, Set result) {
        boolean ok = true;
        for (Iterator it = expected.iterator(); it.hasNext();) {
            String s = (String) it.next();
            if (!result.contains(s)) {
                if (ok) {
                    System.out.println("In test: " + test);
                }
                System.out.println("   expected method call not found: " + s);
                ok = false;
            }
        }

        for (Iterator it = result.iterator(); it.hasNext();) {
            String s = (String) it.next();
            if (!expected.contains(s)) {
                if (ok) {
                    System.out.println("In test: " + test);
                }
                System.out.println("   unexpected method call: " + s);
                ok = false;
            }
        }
        return ok;
    }

    public static void saveBMP(String filename, BufferedImage buffImage) {
        if (!saveEnabled) return;
        try {
            System.out.println(filename);
            Iterator writers = ImageIO.getImageWritersByFormatName("bmp");
            ImageWriter writer = (ImageWriter)writers.next();
            if (writer == null)
            {
                throw new Exception("bmp - no ImageWriter");
            }
            ImageOutputStream ios = ImageIO.createImageOutputStream (new File(filename));
            writer.setOutput(ios);
            writer.write(buffImage);
            ios.flush();
            ios.close();
        } catch (Exception exception) {
            throw new IllegalArgumentException(exception.toString());
        }

    }
    public static void saveSVG(String filename, SVGGraphics2D g2d) {
        if (!saveEnabled) return;
        try{
            g2d.renderSVGImage(new File(filename));
        } catch (Exception exception) {
            throw new IllegalArgumentException("SVG rendering fails.", exception);
        }
    }

}
